-- ZB_DM_XXZBDBFJDMQQB ZB_DM_新续转保单保费季度末前起保
-- key:xxzquarterbf/日期
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、新续转保得保单
-- 2、起保时间的季度小于等于当前季度


-- step1：
-- 团队汇总
CREATE TEMPORARY VIEW VIEW_ZB_DM_XXZBDBFJDMQQB_TUANDUI AS
SELECT
     s1.`uwConclueDate`                    as `uwConclueDate`
    ,s1.`LEVEL1COMCODE`                    as `LEVEL1COMCODE`
    ,s1.`LEVEL2COMCODE`                    as `LEVEL2COMCODE`
    ,s1.`LEVEL3COMCODE`                    as `LEVEL3COMCODE`
    ,s1.`LEVEL4COMCODE`                    as `LEVEL4COMCODE`
    ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `cost`
from (
         select
             *
              ,ROW_NUMBER() OVER(PARTITION BY `no`,`COMCODE`,`cost` ORDER BY `uwConclueDate` DESC) as rownum
         from ZB_ODS.ZB_ODS_KAFKA.CBDATA
         where
             `COMNAME` is not null
           and `uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
     ) s1
where s1.rownum = 1

group by
    s1.`uwConclueDate`
    ,s1.`LEVEL1COMCODE`
    ,s1.`LEVEL2COMCODE`
    ,s1.`LEVEL3COMCODE`
    ,s1.`LEVEL4COMCODE`
;

-- ZB_DM_XXZBDBFJDMQQB ZB_DM_新续转保单保费季度末前起保
-- key:xxzquarterbf/日期
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、新续转保得保单
-- 2、起保时间的季度小于等于当前季度
-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
        'xxzquarterbf/'
        ,s1.`uwConclueDate`
    )                                      as `key`
    ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBFJDMQQB_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
    s1.`uwConclueDate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
        'provxxzquarterbf/'
        ,s1.`uwConclueDate`
    )                                      as `key`
    ,s1.`LEVEL1COMCODE`                    as `hkey`
    ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBFJDMQQB_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
     s1.`uwConclueDate`
    ,s1.`LEVEL1COMCODE`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityxxzquarterbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL2COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBFJDMQQB_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
    s1.`uwConclueDate`
   ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countryxxzquarterbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL3COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBFJDMQQB_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
    s1.`uwConclueDate`
    ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamxxzquarterbf/'
        ,s1.`uwConclueDate`
        )                                   as `key`
     ,s1.`LEVEL4COMCODE`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))      as `val`
from VIEW_ZB_DM_XXZBDBFJDMQQB_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
;